#include <stdio.h>
/*
	SHARP X1 binary to basic converter

	input  : X1turbo SAVEM format binary file
	outout : X1turbo BASIC program file

*/

int main( int argc , char *argv[] )
{
	int er=0;
	FILE *fin , *fout;
	char *ifname,ofname;
	unsigned short start,end;
	unsigned char data[16];
	int j,len;
	int bas_num;

	printf("X1 SAVEM binary to basic program converter Ver 0.2\nCOPYRIGHT(C) 2001 Tatsuyuki Satoh\n");

	if(argc < 3 )
		er=1;
	if(er==1)
	{
		printf(	"usase:x1binbas [inputfile] [outputfile] [option]\n\n"
				"  cmd\n"
				"    -b [saddr] :plane binary to LOADM binary\n"
				"    -h         :LOADM to BASIC file\n");
		return 1;
	}


	if( !(fin = fopen(argv[2],"rb")))
	{
		printf("Can't open input file '%s'\n",argv[1]);
		return NULL;
	}
	if( !(fout = fopen(argv[3],"wt")))
	{
		printf("Can't open output file '%s'\n",argv[2]);
		fclose(fin);
		return NULL;
	}

	switch(argv[1][0]|0x20)
	{
	case 'h': /* 
		encode_file(fsrc,fdst);
		break;
	case 'd':
		decode_file(fsrc,fdst);
		break;
	}
	fclose(fsrc);
	fclose(fdst);
	
	return 0;


	/* convert */
	if( !fread(&start,1,2,fin) || !fread(&end,1,2,fin) )
	{
		printf("Can't read input file '%s'\n",argv[1]);
	}
	else
	{
		/* output header */
		bas_num = 100;
		fprintf(fout,"%d 'binary program '%s'from x1binbas\n",bas_num+=10,argv[1]);
		fprintf(fout,"%d clear &H%04x\n",bas_num+=10,start);
		while( (len = fread(&data,1,16,fin)) > 1 )
		{
			fprintf(fout,"%d mem$(&h%04X,%2d)=hexchr$(\"",bas_num+=10,start,len);
			for(j=0;j<len;j++)
			{
				fprintf(fout,"%02X",data[j]);
			}
			fprintf(fout,"\")\n");
			start+=j;
		}
	}
	fclose(fin);
	fclose(fout);
	if( start != end)
		printf("input file size mismatch!\n");
	else
		printf("Conplete!\n");
}
